<?php
#
# Gestion de las solicitudes de certificado. Permite consultarlas, aprobarlas o
# denegarlas
#

include '../../core.php';

checkAuth($raUrl);

cabecera (2);

$command = $_POST ["csr_command"];

switch ( $command ) {

   default:
      echo "<script type='text/javascript'>
      <!--
      function submit_form() {
         if(confirm (' Esta seguro de que desea aprobar esta solicitud ?')) {
            document.csr_process_accept.submit();
	    return true;
	 }
      }
	
      function notsubmit_form() {
         if (confirm (' Esta seguro de que desea borrar esta solicitud ?')) {
            document.csr_process_del.submit();
	    return true;
	 }
      }
      // -->
      </script>\n";
	
      echo "<h1>Gesti&oacute;n de solicitudes de certificados</h1>

      <h2>Detalles de la solicitud</h2>\n";
   
      $strGet=$_GET["copa"];
      list($copa, $ident, $fecha) = split('\?', $strGet);
   
      // Buscamos el estado y el pin del certificado del usuario con la codificacion copa
      $filter = "(&(objectclass=pkirisCertificate)(pkirisCopaID=$copa))";
      $justthese = array ("pkirisstatus", "pkirispin");

      $result = ldap_get_info ($base, $filter, $justthese);	
   
      list($copaUsr , $kk) = split ('c', $copa);

      // Buscamos la informacion del usuario con la codificacion copa
      $filter2 = "(&(objectclass=pkirisEndEntity)(pkirisCopaID=$copaUsr))";
      $justthese2 = array ("cn", "sn", "mail", "telephonenumber");

      $result2 = ldap_get_info ($base, $filter2, $justthese2);
	
      $cn=$result2[0]["cn"][0];
      $sn=$result2[0]["sn"][0];
      $mail=$result2[0]["mail"][0];
      $tel=$result2[0]["telephonenumber"][0];
      $status=$result[0]["pkirisstatus"][0];
      $pin=$result[0]["pkirispin"][0]; 
	
      echo "
      <div id='tbox'>
        <h3 class='head_a2b1'>Detalles solicitud</h3>
        <div id='tbox_data_a2'>
          <div id='trow'>
            <div id='tname'>Autoridad de Registro</div>
            <div id='tvalue'>$raName</div>
          </div>
          <div id='trow'>
            <div id='tname'>C&oacute;digo de Solicitud</div>
            <div id='tvalue'>$copa</div>
          </div>
          <div id='trow'>
            <div id='tname'>Identificador</div>
            <div id='tvalue'>$ident</div>
          </div>
          <div id='trow'>
            <div id='tname'>Nombre</div>
            <div id='tvalue'>$cn $sn</div>
          </div>
          <div id='trow'>
            <div id='tname'>Mail</div>
            <div id='tvalue'>$mail</div>
          </div>
          <div id='trow'>
            <div id='tname'>Tel&eacute;fono</div>
            <div id='tvalue'>$tel</div>
          </div>
          <div id='trow'>
            <div id='tname'>Fecha de Solicitud</div>
            <div id='tvalue'>$fecha</div>
          </div>
          <div id='trow'>
            <div id='tname'>Estado</div>
            <div id='tvalue'>$status</div>
          </div>
        </div>
      </div>
      ";

      echo "
      <div id='tbox'>
        <h3 class='head_a2b1'>Operaciones disponibles</h3>
        <div id='tbox_data_a1'>
      <form method='post' action='' enctype='multipart/form-data' name='csr_chk_pin'>
          <div id='trow'>
            <div id='tname'>
            </div>
            <div id='tvalue'>
               <input class='button' type='submit' value='Verificar PIN' />
               <input type='password' name='csr_pin'  size='10' /> 
";
      if (isset($_POST["csr_pin"])) {
         if (crypt($csr_pin, $result[0]["pkirispin"][0]) == $result[0]["pkirispin"][0]) {
            echo "PIN Ok";
         }
         else {
            echo "PIN Error";
         }
      }
echo "
            </div>
          </div>
      </form>

          <div id='trow'>
            <div id='tname'></div>
            <div id='tvalue'>
      <form method='post' action='csr_manage.php' enctype='multipart/form-data' name='csr_process_accept'>
      <input type='hidden' name='copa' value='$copa' />
      <input type='hidden' name='ident' value='$ident' />
      <input type='hidden' name='cn' value='$cn' />
      <input type='hidden' name='sn' value='$sn' />
      <input type='hidden' name='mail' value='$mail' />
      <input type='hidden' name='tel' value='$tel' />
      <input type='hidden' name='fecha' value='$fecha' />
      <input type='hidden' name='csr_command' value='csr_accept' />
               <input class='button' type='button' value='Aprobar solicitud' onclick='submit_form()' />
               <input type='text' name='comments' size='20' />
               Comentarios (opcional)
      </form>
            </div>
          </div>
          <div id='trow'>
            <div id='tname'></div>
            <div id='tvalue'>
      <form method='post' action='csr_manage.php' enctype='multipart/form-data' name='csr_process_del'>
      <input type='hidden' name='copa' value='$copa' />
      <input type='hidden' name='ident' value='$ident' />
      <input type='hidden' name='cn' value='$cn' />
      <input type='hidden' name='sn' value='$sn' />
      <input type='hidden' name='mail' value='$mail' />
      <input type='hidden' name='tel' value='$tel' />
      <input type='hidden' name='fecha' value='$fecha' />
      <input type='hidden' name='csr_command' value='csr_del' />
               <input class='button' type='button' value='Borrar solicitud' onclick='notsubmit_form()' /> 
               <input type='text' name='comments' size='20' />
               Comentarios (opcional)
      </form>
            </div>
          </div>
          <div id='trow'>
            <div id='tname'></div>
            <div id='tvalue'>
      <input class='button' type='button' value='Volver' onclick='history.back()' />
            </div>
          </div>

        </div>
      </div>
      ";


/*
      echo "
	      
	
      <br/>

      <form method='post' action='csr_manage.php' enctype='multipart/form-data' name='csr_process_accept'>
      Comentarios (opcional) <br>
      <input type='text' name='comments' size='20' />
      <input type='button' value='Aprobar solicitud' onclick='submit_form()' />
      <input type='hidden' name='copa' value='$copa' />
      <input type='hidden' name='ident' value='$ident' />
      <input type='hidden' name='cn' value='$cn' />
      <input type='hidden' name='sn' value='$sn' />
      <input type='hidden' name='mail' value='$mail' />
      <input type='hidden' name='tel' value='$tel' />
      <input type='hidden' name='fecha' value='$fecha' />
      <input type='hidden' name='csr_command' value='csr_accept' />
      </form>
	  
      <form method='post' action='csr_manage.php' enctype='multipart/form-data' name='csr_process_del'>
      <br>
      <input type='text' name='comments' size='20' />
      <input type='button' value='Borrar solicitud' onclick='notsubmit_form()' /> <br><br>
      <input type='button' value='Volver' onclick='history.back()' />
      <input type='hidden' name='copa' value='$copa' />
      <input type='hidden' name='ident' value='$ident' />
      <input type='hidden' name='cn' value='$cn' />
      <input type='hidden' name='sn' value='$sn' />
      <input type='hidden' name='mail' value='$mail' />
      <input type='hidden' name='tel' value='$tel' />
      <input type='hidden' name='fecha' value='$fecha' />
      <input type='hidden' name='csr_command' value='csr_del' /> 
      </form>\n";
*/
   break;      

   case "csr_accept":
      echo "<h1 class='title'>Gesti&oacute;n de solicitudes de certificados</h1>
      <h3> Resultado de la Solicitud </h3>\n";

      $lastStatus = getStatus($copa);
      // Esta comprobacion se hace para evitar que se escriba dos veces la 
      // misma traza al recargar el navegador
      if ($lastStatus == "new" || $lastStatus == "renew"){      
         $status = "approved";
         $currentDate = date("YmdHis");
         $dn = $rdn1."=".$copa.",".$base;

         $traceVals["status"] = $status;
         $traceVals["copa"] = $copa;
         $traceVals["currentDate"] = $currentDate;
	 $traceVals["comments"] = $comments;

         // Generamos la traza con los valores de $traceVals
         $pkiTrace = getTrace($traceVals);
      
         // Modificamos el campo pkiDAte y pkiStatus del ldap.
         $updateFields["pkirisstatus"] = 'approved';
         $updateFields["pkirisdate"] = $currentDate;

         $mod = ldap_mod_info ($dn, $updateFields);

         // Modificamos el campo pkiTrace para agregar la traza firmada.
         $urn["pkiristrace"] = $pkiTrace;
      
         $mod = ldap_mod_add_info ($dn, $urn);
	   
         echo "<p> Su solicitud ha sido procesada. </p>
         <h3> Detalles de ls Solicitud </h3>\n
         <table border='1' cellpadding='2' cellspacing='0'>
         <tr><td>Autoridad de Registro</td><td><b>$raName</b></td></tr>
         <tr><td>N&uacute;mero de Serie</td><td>$copa</td></tr>
         <tr><td>Identificador</td><td>$ident</td></tr>
         <tr><td>Nombre</td><td>" . $cn . " " . $sn ."</td></tr>
         <tr><td>Mail</td><td>" . $mail . "</td></tr>
         <tr><td>Tel&eacute;fono</td><td>" . $tel . "</td></tr>
         <tr><td>Fecha de Solicitud</td><td> $fecha </td></tr>
         <tr><td>Estado</td><td>$status</td></tr>
         </table>";
      }
      else 
	 echo "<h1>Error Gestionando la Solicitud</h1>
	 <p>Su solicitud ya ha sido procesada anteriormente. Tiene el estado $status</p>";     

   break;	   
   
   case "csr_del":
      echo "<h1 class='title'>Gesti&oacute;n de solicitudes de certificados</h1>
      <h3> Resultado de la Solicitud </h3>\n";

      $lastStatus = getStatus($copa);
      // Esta comprobacion se hace para evitar que se escriba dos veces la
      // misma traza al recargar el navegador
      if ($lastStatus == "new" || $lastStatus == "renew"){
         
	 if ($lastStatus == "new")
	    $status = "csr-denied";     
	 else
	    $status = "rnr-denied";
	    
         $currentDate = date("YmdHis");
         $dn = $rdn1."=".$copa.",".$base;
            
         $traceVals["status"] = $status;       
         $traceVals["copa"] = $copa;
         $traceVals["currentDate"] = $currentDate;
         $traceVals["comments"] = $comments;

         // Generamos la traza con los valores de $traceVals
         $pkiTrace = getTrace($traceVals);
      
         // Modificamos el campo pkiDAte y pkiStatus del ldap.
         $updateFields["pkirisstatus"] = $status;
         $updateFields["pkirisdate"] = $currentDate;
	    
         $mod = ldap_mod_info ($dn, $updateFields);	

         // Modificamos el campo pkiTrace para agregar la traza firmada.
         $urn["pkiristrace"] = $pkiTrace;
      
         $mod = ldap_mod_add_info ($dn, $urn);
         echo "<p> Su solicitud ha sido cancelada. </p>
         <h3> Detalles de la Solicitud </h3>\n
         <table border='1' cellpadding='2' cellspacing='0'>
         <tr><td>Autoridad de Registro</td><td><b>$raName</b></td></tr>
         <tr><td>C&oacute;digo de solicitud</td><td>$copa</td></tr>
         <tr><td>Identificador</td><td>$ident</td></tr>
         <tr><td>Nombre</td><td>" . $cn . " " . $sn ."</td></tr>
         <tr><td>Mail</td><td>" . $mail . "</td></tr>
         <tr><td>Tel&eacute;fono</td><td>" . $tel . "</td></tr>
         <tr><td>Fecha de Solicitud</td><td> $fecha </td></tr>
         <tr><td>Estado</td><td> $status </td></tr>
         </table>\n";
      }
      else
         echo "<h1>Error Gestionando la Solicitud</h1>
	 <p>Su solicitud ya ha sido procesada anteriormente. Tiene el estado $status</p>";
   break;
}
	
pie ();

?>

