<?php

include '../../core.php';

checkAuth("pkiAdmin");

cabecera (3);

// El siguiente script valida los datos del formulario.
echo "<script language='JavaScript'>
<!--
function submit_form() {

   if (document.newRa_form.ra_url_name.value == '' || 
       document.newRa_form.ra_url_name.value.search(/[^a-z,A-Z,0-9,\_,\-]/i) >= 0) {
      alert ('Por favor introduzca una URL correcta. Solo puede escribir caracteres de la \'a\' a la \'z\', números y los signos \'-\' y \'_\'');
      document.newRa_form.ra_url_name.focus();
      return false;
   }
   if (document.newRa_form.ra_pass.value != document.newRa_form.ra_retype_pass.value) {
      alert ('Las claves no coinciden');
      document.newRa_form.ra_pass.focus();
      return false;
   }
			   
   document.newRa_form.submit();
   return true;
}
// -->
</script>";
		
echo "<h1 class='title'>Creaci&oacute;n de nueva Autoridad de Registro</h1>";

$command = $_POST["command_newra"];

switch ( $command ) {
   default :
      echo "<div id='tbox'>
         <h3 class='head_a2b1'>Datos de la nueva RA</h3>
            <div id='tbox_data_a1'>
      	    <form method='post' action='newRa.php' name='newRa_form'>
	    <div id='trow'>
               <div id='tname'>URL de la RA:</div>
	       <div id='tvalue'>
	          <input type='text' name='ra_url_name'  size='30' minlen='7' />
	       </div>
	    </div>
	    <div id='trow'>
               <div id='tname'>Nombre para la RA:</div>
	       <div id='tvalue'>
	          <input type='text' name='ra_name'  size='30' minlen='7' />
	       </div>
	    </div>
	    <div id='trow'>
               <div id='tname'>Descripci&oacute;n de la RA:</div>
	       <div id='tvalue'>
	          <input type='text' name='ra_descr'  size='40' minlen='7' />
	       </div>
	    </div>
	    <div id='trow'>
               <div id='tname'>Responsable de la RA:</div>
               <div id='tvalue'>
	          <input type='text' name='ra_respname'  size='35' minlen='7' />
	       </div>
	    </div>
	    <div id='trow'>
               <div id='tname'>Ubicaci&oacute;n f&iacute;sica de la RA:</div>
               <div id='tvalue'>
	          <input type='text' name='ra_loc'  size='40' minlen='7' />
	       </div>
	    </div>
	    <div id='trow'>
               <div id='tname'>Clave de la RA:</div>
               <div id='tvalue'>
	          <input type='password' name='ra_pass'  size='30' minlen='7' />
	       </div>
	     </div>
	     <div id='trow'>
                <div id='tname'>Repita la Clave:</div>
                <div id='tvalue'>
	           <input type='password' name='ra_retype_pass'  size='30' minlen='7' />
		</div>
	     </div>
          </div> <!-- tbox_data_a1 -->
        </div> <!-- tbox -->\n";
	     
	echo "<div id='tbox'>
            <h3 class='head_a2b1'>Dominio/RDN Organizaci&oacute;n</h3>

            <div id='tbox_data_a1'>
	     <div id='trow'>
                <div id='tvalue'>Dominio: <input type='text' name='domain1'  size='20' /> 
                RDN Organizaci&oacute;n: <input type='text' name='org1'  size='20' minlen='7' /></div>
	     </div>
	     <div id='trow'>
                <div id='tvalue'>Dominio: <input type='text' name='domain2'  size='20' />
                RDN Organizaci&oacute;n: <input type='text' name='org2'  size='20' /></div>
	     </div>
	     <div id='trow'>
                <div id='tvalue'>Dominio: <input type='text' name='domain3'  size='20' />
                RDN Organizaci&oacute;n: <input type='text' name='org3'  size='20' /></div>
	     </div>
	     <div id='trow'>
                <div id='tvalue'>Dominio: <input type='text' name='domain4'  size='20' /> 
                RDN Organizaci&oacute;n: <input type='text' name='org4'  size='20' /></div>
	     </div>
	      <div id='trow'>
                 <div id='tvalue'>
                    <input class='button' type='button' value='Continuar' onClick='submit_form()'>
                 </div>
              </div>
              <input type='hidden' name='command_newra' value='create_ra'>
           </form>
        </div> <!-- tbox_data_a1 -->
     </div> <!-- tbox -->\n";
   break;						

   case "create_ra":
      // Antes de nada, comprobamos que no exista una RA con el mismo nombre o
      // la misma URL de la que queremos crear
      $newRaUrl = $_POST["ra_url_name"];
      $newRaName = $_POST["ra_name"];
      $filter = "(&(objectClass=pkirisAuthority)(|(pkirisRaUrl=$newRaUrl)(pkirisName=$newRaName)))";
      $justthese = array();
      $result = ldap_get_info($base, $filter, $justthese);

      if ( $result["count"] != 0 ) {
	 $errorNumber = 69;
         $errorCounter ++; 
	 echo "\n<p>Ya existe una RA con esos datos. Dos RAs diferentes no pueden tener la misma URL ni el mismo nombre. Por favor, introduzca unos valores diferentes.</p>";
      }
      else {
         //Creamos el fichero de configuracion de la RA
     	
         // Obtenemos el numero de Autoridades de registro que hay en el sistema
         $filter = "(objectClass=pkirisAuthority)";
         $justthese = array("dn");
         $result = ldap_get_info($base, $filter, $justthese);

         $newRaNum = "a".count($result); 
         $newRaUrl = $newRaUrl;
         $newRaName = $newRaName;
         $newRaDescr = $_POST["ra_descr"];
         $newRaRespName = $_POST["ra_respname"];
         $newRaLoc = $_POST["ra_loc"];
         $newRaPass = $_POST["ra_pass"];
         $currentDate = date("YmdHis");

         // Creamos el array que contendra todas las claves privadas que vaya 
         // teniendo la RA. Cada vez que cambiemos la clave, la valida sera mas
         // cercana a la fecha actual, pero siempre menor que ella
         $raPrivKeyArray = array();

         $raStringFile = "<?php\n\nglobal \$raNum;\nglobal \$raName;\nglobal \$raPrivKey;\nglobal \$raDomains;\n\n\$raNum = \"$newRaNum\";\n\$raName = \"$newRaName\";\n\$raUrl = \"$newRaUrl\";\n\n\$raPrivKey = \"$newRaPass\";\n\n\$raDomains = array (\n";
      
            //if ((isset($_POST["domain1"])) && (isset($_POST["domain2"])) && (isset($_POST["domain3"])) && (isset($_POST["domain4"]))) {
            if (($domain1 != NULL) && ($domain2 != NULL) && ($domain3 != NULL) && ($domain4 != NULL)) {
               $raStringFile = $raStringFile ."\"$domain1\" => array (\n\"domain\" => \"$org1,\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
               $raStringFile = $raStringFile ."\"$domain2\" => array (\n\"domain\" => \"$org2,\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
               $raStringFile = $raStringFile ."\"$domain3\" => array (\n\"domain\" => \"$org3,\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
               $raStringFile = $raStringFile ."\"$domain4\" => array (\n\"domain\" => \"$org4,\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
            }
            else {
	       if (($domain1 != NULL) && ($domain2 != NULL) && ($domain3 != NULL)) {
                  $raStringFile = $raStringFile ."\"$domain1\" => array (\n\"domain\" => \"$org1,\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
                  $raStringFile = $raStringFile ."\"$domain2\" => array (\n\"domain\" => \"$org2,\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
                  $raStringFile = $raStringFile ."\"$domain3\" => array (\n\"domain\" => \"$org3,\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
      	       }
	       else {
	          if (($domain1 != NULL) && ($domain2 != NULL)) {
                     $raStringFile = $raStringFile ."\"$domain1\" => array (\n\"domain\" => \"$org1,\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
                     $raStringFile = $raStringFile ."\"$domain2\" => array (\n\"domain\" => \"$org2,\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
	          }
	          else {
                     $raStringFile = $raStringFile ."\"$domain1\" => array (\n\"domain\" => \"$org1,\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
	          }
	       }
            }
	  
         $raStringFile = $raStringFile . ");\n\n\$raPrivKeyArray['$newRaNum']['$currentDate'] = \"$newRaPass\";\n\n?>";
	      
         $raConfFile = fopen($confDir."php/$newRaUrl".".conf", "w+");
         $result = fputs($raConfFile, $raStringFile);
         fclose($raConfFile);

         if (!$result) {
            echo "El Fichero de configuraci&oacute;n no se ha generado correctamente";
         }
         else {
            // Creamos la entrada en el Ldap
            $info["objectClass"][0]="top";
            $info["objectClass"][1]="irisObject";
            $info["objectClass"][2]="pkirisAuthority";
            $info[$rdn1]=$newRaNum;
            $info["pkirisID"]=$newRaNum;
            $info["pkirisName"]=$newRaName;
            $info["pkirisRaUrl"]=$newRaUrl;
            $info["pkirisCounter"]="0";
            $info["pkirisCopaID"]=$newRaNum;
            $info["description"]=$newRaDescr;

            // Guardamos la informacion del ususario que hace la CSR
            $r=ldap_add_info($rdn1."=".$newRaNum.",".$base, $info);

   	    if ($r) {
               // Creamos el link simbolico para el apache
   #echo "<hr>".$rootDir.$newRaUrl."<hr>";
   	       $linkResult = symlink($rootDir."pki", $rootDir.$newRaUrl);
	       if ($linkResult) {
	          // Exportamos la clave privada de la RA
	          $exportResult = exportRaPrivKey($newRaNum, $currentDate);
	          if ( $exportResult ) {
                     echo "<p>La Autoridad de Registro \"$newRaName\" ha sido creada con &eacute;xito.
   	             Para su total funcionamiento tendr&aacute; que generar una redirecci&oacute;n en su servidor web 
	             que apunte de /$newRaUrl/ a $securePkiUrl$newRaUrl. Para m&aacute;s informaci&oacute;n consulte el manual
	             de usuario.</p>";
	          }
	          else {
		     echo "<p>Existen problemas en la creaci&oacute;n la Autoridad de Registro $newRaName,
   		     no se ha podido exportar la clave privada.</p>";
	          }
               } 
	       else {
                  echo "<p>Hay un problema en la creaci&oacute;n la Autoridad de Registro <b>$newRaName</b>. 
                  Necesitamos crear un link simb&oacute;lico y el sistema no nos deja.
	          Por favor verifique que tiene los permisos necesarios para escribir en los directorios
   	          de la aplicaci&oacute;n y vuelva a intentarlo.</p>";
               }
            }   
	    else {
               echo "<p>Existen problemas en la creaci&oacute;n de la Autoridad de Registro $newRaName,
               por favor verifique que tiene los permisos necesarios para escribir en los directorios
               de la aplicaci&oacute;n y vuelva a intentarlo. Funcin: ldap_add_info</p>";
            }
         }
      }
   break;
}

pie ();

?>
