<?php

include '../../core.php';

checkAuth("pkiAdmin");

cabecera (3);

// El siguiente script se encarga de
echo "<script type='text/javascript'>
<!--
function perms_selection(index) 
{
   	
   document.perms_form.elements[4*index+2].value='';
   document.perms_form.elements[4*index+1].length='2';

   document.perms_form.elements[4*index+1].options[0].value='En Pruebas';
   document.perms_form.elements[4*index+1].options[0].text='En Pruebas';

   valor = document.perms_form.elements[4*index][document.perms_form.elements[4*index].selectedIndex].value;
   for (i = 0; i < document.perms_form.elements[4*index+3].length; i++) {
      alert(document.perms_form.elements[4*index+3].value[i]);
   }
   valor2 = document.perms_form.elements[4*index+3].value[valor].value;
   alert (valor2);
   document.perms_form.elements[4*index+1].options[1].value='HOLA2';
   document.perms_form.elements[4*index+1].options[1].text='HOLA2'; 
   return true; 
}
//-->
</script>\n";
																	 
echo "<h1 class='title'>Gesti&oacute;n de Usuarios de la PKI</h1>";

$command = $_POST["command"];

switch ( $command ) {
   default :
      echo "<h2>Seleccione los permisos que desea otorgarle a cada usuario para cada RA</h2>\n";

      // Lo primero que hacemos, es obtener una lista de todas las RAs del
      // sistema
      $filter = "(objectClass=pkirisAuthority)";
      $justthese = array("pkirisRaUrl");
      $result = ldap_get_info($base, $filter, $justthese);

      if (!$result) {
         $error = 69;
         echo "<h2>No se ha encontrado ninguna Autoridad de Registro en el sistema.</h2>";
      }
      else {
        // Metemos las urls de las RAs en un array 
	$urlsArray = array();
	for($i = 0; $i < $result["count"]; $i++) {
	   $queryUrl = $result[$i]["pkirisraurl"][0];
           $urlsArray[$i] = $queryUrl;
        }
	// Ademas de las urls de las RAs, tambien tenemos que meter las urls
	// de la parte de administracion de la pki y de operadores de la CA
	array_push($urlsArray, "pkiOper");
	array_push($urlsArray, "pkiAdmin");
      }	
      // Buscamos los certificados firmados de tipo usuario que existen en 
      // el sistema 
      $filter = "(&(objectClass=pkirisCertificate)(pkirisCertType=usr)(pkirisStatus=issued))";
      $justthese = array("pkirisCopaID");
      $result = ldap_get_info($base, $filter, $justthese);

      if (!$result){
         $error = 69;
         echo "<h2>No se ha encontrado ningi&uacute;n certificado v&aacute;lido en el sistema.</h2>";
      }
      else {
         echo "<form name='perms_form'>
	 <table border='0' cellpadding='0' cellspacing='0' !width='100%'>
         <tr>
	 <td class='header'>Copa Id</td>
	 <td class='header'>Nombre del usuario</td>
	 <td class='header'>URL</td>
	 <td class='header'>Permisos para la URL</td>
	 <td class='header'>Cambiar permisos</td>
	 </tr>\n";

         for( $i = 0; $i < $result["count"]; $i++ ) { 
	    // Para cada certificado valido, obtenemos los permisos del usuario
	    // correspondiente
	    $copa = $result[$i]['pkiriscopaid'][0];
	    list ($userCopa, $k) = split ("c", $copa);
	    
            $filter2 = "(&(objectClass=irisObject)(objectClass=pkirisEndEntity)(objectClass=irisPerson)(pkirisCopaID=$userCopa))";
            $justthese2 = array("sn", "cn", "irisUserEntitlement");
            $result2 = ldap_get_info($base, $filter2, $justthese2);
            
	    $userFullName = $result2[0]["cn"][0] . " " .$result2[0]["sn"][0];
	    
	    // Obtenemos los permisos del usuario para cada RA
	    $permsArray = array();
	    for( $j = 0; $j < $result2[0]['irisuserentitlement']['count']; $j++ ) {
               list($k1,$k2,$k3,$k4,$k5,$attr,$value)=split(":",$result2[0]['irisuserentitlement'][$j]);
	       $permsArray[$attr] = $value;
	    }
            if ($i%2==0) {
   	      echo "<tr>
                <td class='even'> $userCopa </td>
                <td class='even'> $userFullName </a></td>
		<td class='even'> <select name = 'urlList_$i' onchange='perms_selection($i)'>
		    <option value='0' selected> Seleccione</option>";
		    while (list ($index,$value) = each ($urlsArray))
		      echo "<option value = $value> $value </option>";
		  echo "</select></td>
                <td class='even'> <select name = 'userPerms_$i'>
                    <option value='-'> - </option>
                  </select></td>
		  <td class='even'><input class='form_input' type='text' name='pepe_$i' value='Cambiar Permisos'/> </td>
		  <input type='hidden' name='permsArray_$i' value='$permsArray'/> 
              </tr>";
	    }
	    else {
               echo "<tr>
	         <td class='odd'> $userCopa </td>
	         <td class='odd'> $userFullName </a></td>
		 <td class='odd'> <select name = 'urlList_$i' onchange='perms_selection($i)'>
		     <option value='0' selected> Seleccione</option>";
		     while (list (,$value) = each ($urlsArray))
                       echo "<option value = $value> $value </option>";
                   echo "</select></td>
		 <td class='odd'> <select name = 'userPerms_$i'> 
		     <option value='-'> - </option>
                   </select></td>
		   <td class='odd'> <input class='form_input' type='text' name='pepe_$i' value='Cambiar Permisos'/> </td>
		   <input type='hidden' name='permsArray_$i' value='$permsArray'/> 
	       </tr>";
	    }
	    // Reseteamos el puntero del array
            reset ($urlsArray);   
	 }
         echo "</table></form>";
      }
      break;

      case "have_copa":
	 if ($certs > 0) 
      break;
}
											      
pie ();

?>
